#!/bin/sh
#
# Copyright 1999 by Dag Wieers. Subject to the GPL.
#
# Author:
#              Dag Wieers <dag@mind.be>
#
# Please send suggestions and improvements to: dag@mind.be

DEBUG=no
SERVICE="pi"

if [ $# -lt 2 ]; then
	echo "Usage: $0 [prefix] [gsmnr]"; exit 1
fi

PREFIX=$1;shift
GSMNR=$1;shift
read MESSAGE

LENGTH=`echo "$MESSAGE" | wc -c`
MESSAGE=`echo $MESSAGE | perl -lpe '$_=~s{([^a-zA-Z0-9-])}{"%".unpack("H",$1).unpack("h",$1)}eg'`

################################################################################
case "$SERVICE" in
infobel) # <- INFOBEL -> 
	NUM=`expr 115 - $LENGTH`

	SERVER_PORT="www.infobel.be 80"
	SCRIPT="/infobel/smsresult.asp"
	HOST="www.infobel.be:80"
	REFERER="http://www.infobel.be/infobel/sms.asp"
	CONTENT="area=$PREFIX&gsm=$GSMNR&message=$MESSAGE&chars=$NUM"
	SUCCESS="Your message was sent successfully"
;;
skynet) # <- SKYNET ->
	SERVER_PORT="sms.skynet.be 80"
	SCRIPT="/cgi-bin/StephSMS2.cgi"
	HOST="sms.skynet.be:80"
	REFERER="http://www.belcast.be/en/sms/right.html"
	CONTENT="next=http%3A%2F%2Fwww.belcast.be%2Fen%2Fhome%2Fright.html&msg=$MESSAGE&prefix=$PREFIX&tel=$GSMNR"
	SUCCESS="/skynet/mobile/sent.html"
;;
sms-it) # <- SMS-IT ->
	SERVER_PORT="www.sms-it.com 80"
	SCRIPT="/sms/sms-it2.nsf/8de9b748d6d31d30412567260037ab9e?CreateDocument"
	HOST="www.sms-it.be:80"
	REFERER="http://www.sms-it.com/sms/sms-it2.nsf/8de9b748d6d31d30412567260037ab9e?OpenForm"
	CONTENT="Prefix=$PREFIX&Number=$GSMNR&Message=$MESSAGE"
	SUCCESS="Your message has been submitted successfully!"
;;
pi) # <- PI ->
	SERVER_PORT="www.planetinternet.be 80"
	SCRIPT="/cgi-bin/sendsms.cgi"
	HOST="www.planetinternet.be:80"
	REFERER="http://www.planetinternet.be/"
	CONTENT="prefix=$PREFIX&number=$GSMNR&msg=$MESSAGE"
	SUCCESS="Het volgende bericht werd gestuurd"
;;
*) # <- ADVALVAS ->
	NUM=`expr 120 - $LENGTH`

	SERVER_PORT="sms.advalvas.be 80"
	SCRIPT="/scripts/ProxiTextint.dll"	
	HOST="sms.advalvas.be:80"
	REFERER="http://sms.advalvas.be/"
	CONTENT="MfcISAPICommand=SendText&origin=adva&intlPrefix=%2B$PREFIX&PREFIX=%2B$PREFIX&tel=$GSMNR&bericht=$MESSAGE&num=$NUM&x=20&y=8"
	SUCCESS="Your message was sent successfully."
;;
esac
################################################################################

CONTENT_LENGTH=`echo "$CONTENT" | wc -c`

if [ "$DEBUG" == "yes" ]; then
	echo $SCRIPT
	echo $CONTENT
fi

cat <<END | nc $SERVER_PORT | grep -i "$SUCCESS" >/dev/null 2>&1
POST $SCRIPT HTTP/1.0
Connection: Keep-Alive
User-Agent: Mozilla/4.7 [en] (X11; I; Linux 2.2.14pre9 i686; Nav)
Host: $HOST
Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*
Accept-Encoding: gzip
Accept-Language: en
Accept-Charset: iso-8859-1,*,utf-8
Content-type: application/x-www-form-urlencoded
Content-length: $CONTENT_LENGTH
Referer: $REFERER

$CONTENT
END
rc=$?

if [ "$DEBUG" == "yes" ]; then
	if [ $rc -ne 0 ]; then
		echo "Not succesfully sent."	
	fi
fi

exit $rc
